# gnome-shell-signal-tracker

GNOME Shell extension utility for tracking objects implementing the GJS signal
emitter interface (Signals.addSignalMethods).

## Building

This module uses ES6 classes and exports. To use in an extension, use a
transpiler like Babel and a module bundler like Webpack.

## Usage

```javascript
import { SignalTracker, ShellWindowTracker, ShellWorkspaceTracker } from 'gnome-shell-signal-tracker';

const signals = new SignalTracker();
const windows = new ShellWindowTracker(signals);

function enable() {
  signals.connect(global.screen, 'workspace-switched', () => print('switched workspace'));
  windows.onEvery(win => print('found a new window'));
  windows.connectEvery('focus', win => print('focused a window'));
}

function disable() {
  signals.clean();
}
```

## Documentation

For now, the JSDoc annotations in the source.
